Package com.xebialabs.deployit.plugin.api.reflect

# Interface IDescriptorRegistry

All Superinterfaces:
  `AutoCloseable`

All Known Implementing Classes:
  `BaseDescriptorRegistry`

public interface IDescriptorRegistry extends AutoCloseable

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT_PRECEDENCE`
  `static final int`
  `HIGHEST_PRECEDENCE`
  `static final int`
  `LOWEST_PRECEDENCE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default void`
  `close()`
  `boolean`
  `exists(Type type)`
  `Descriptor`
  `getDescriptor(Type type)`
  `Collection<Descriptor>`
  `getDescriptors()`
  `List<DescriptorRegistryHook>`
  `getHooks()`
  `DescriptorRegistryId`
  `getId()`
  `default int`
  `getOrder()`
  `Collection<Type>`
  `getSubtypes(Type supertype)`
  `boolean`
  `isDefault()`
  `boolean`
  `isLocal()`
  `Type`
  `lookupType(Class<?> ciClass)`
  `Type`
  `lookupType(String typeName)`
  `Type`
  `lookupType(String prefix, String simpleName)`
  `void`
  `register(Descriptor descriptor)`
  `void`
  `registerHook(DescriptorRegistryHook hook)`
  `void`
  `registerSubtype(Type supertype, Type subtype)`
  `void`
  `verifyTypes()`

- ## Field Details

  - ### HIGHEST_PRECEDENCE

    static final int HIGHEST_PRECEDENCE
    See Also:
      - Constant Field Values

  - ### LOWEST_PRECEDENCE

    static final int LOWEST_PRECEDENCE
    See Also:
      - Constant Field Values

  - ### DEFAULT_PRECEDENCE

    static final int DEFAULT_PRECEDENCE
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getId

    DescriptorRegistryId getId()

  - ### lookupType

    Type lookupType(String typeName)

  - ### lookupType

    Type lookupType(Class<?> ciClass)

  - ### lookupType

    Type lookupType(String prefix, String simpleName)

  - ### isLocal

    boolean isLocal()

  - ### isDefault

    boolean isDefault()

  - ### getOrder

    default int getOrder()

  - ### getDescriptors

    Collection<Descriptor> getDescriptors()

  - ### exists

    boolean exists(Type type)

  - ### getDescriptor

    Descriptor getDescriptor(Type type)

  - ### getSubtypes

    Collection<Type> getSubtypes(Type supertype)

  - ### register

    void register(Descriptor descriptor)

  - ### registerSubtype

    void registerSubtype(Type supertype, Type subtype)

  - ### verifyTypes

    void verifyTypes()

  - ### close

    default void close() throws Exception
    Specified by:
      `close` in interface `AutoCloseable`
    Throws:
      `Exception`

  - ### registerHook

    void registerHook(DescriptorRegistryHook hook)

  - ### getHooks

    List<DescriptorRegistryHook> getHooks()